From dda2ba0390ed3203e9baf8f4a9601d1ffa3bebfb Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Mon, 8 Jun 2015 17:54:26 +0200
Subject: [PATCH 2/3] kernel/drm: Upgrade drm_pciids.h to Linux 3.11's.

---
 sys/dev/drm/include/drm/drm_pciids.h | 61 +++++++++++++++++++++++++++++++++++-
 1 file changed, 60 insertions(+), 1 deletion(-)

diff --git a/sys/dev/drm/include/drm/drm_pciids.h b/sys/dev/drm/include/drm/drm_pciids.h
index c72f29e..dae978e 100644
--- a/sys/dev/drm/include/drm/drm_pciids.h
+++ b/sys/dev/drm/include/drm/drm_pciids.h
@@ -1,5 +1,5 @@
 /*
- * $FreeBSD: head/sys/dev/drm2/drm_pciids.h 254852 2013-08-25 12:20:57Z dumbbell $
+ * $FreeBSD$
  */
 
 /*
@@ -153,6 +153,33 @@
 	{0x1002, 0x5E4C, CHIP_RV410|RADEON_NEW_MEMMAP, "ATI Radeon RV410 X700 SE"}, \
 	{0x1002, 0x5E4D, CHIP_RV410|RADEON_NEW_MEMMAP, "ATI Radeon RV410 X700"}, \
 	{0x1002, 0x5E4F, CHIP_RV410|RADEON_NEW_MEMMAP, "ATI Radeon RV410 X700 SE"}, \
+	{0x1002, 0x6600, CHIP_OLAND|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Mars [Radeon HD 8670A/8670M/8750M]"}, \
+	{0x1002, 0x6601, CHIP_OLAND|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Mars [Radeon HD 8730M]"}, \
+	{0x1002, 0x6602, CHIP_OLAND|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Mars"}, \
+	{0x1002, 0x6603, CHIP_OLAND|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Mars"}, \
+	{0x1002, 0x6606, CHIP_OLAND|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Mars XTX [Radeon HD 8790M]"}, \
+	{0x1002, 0x6607, CHIP_OLAND|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Mars LE [Radeon HD 8530M / R5 M240]"}, \
+	{0x1002, 0x6610, CHIP_OLAND|RADEON_NEW_MEMMAP, "Oland XT [Radeon HD 8670 / R5 340X / R7 250/350X]"}, \
+	{0x1002, 0x6611, CHIP_OLAND|RADEON_NEW_MEMMAP, "Oland [Radeon HD 8570 / R7 240/340 OEM]"}, \
+	{0x1002, 0x6613, CHIP_OLAND|RADEON_NEW_MEMMAP, "Oland PRO [Radeon R7 240]"}, \
+	{0x1002, 0x6620, CHIP_OLAND|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Mars"}, \
+	{0x1002, 0x6621, CHIP_OLAND|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Mars PRO"}, \
+	{0x1002, 0x6623, CHIP_OLAND|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Mars"}, \
+	{0x1002, 0x6631, CHIP_OLAND|RADEON_NEW_MEMMAP, "Oland"}, \
+	{0x1002, 0x6640, CHIP_BONAIRE|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Saturn XT [FirePro M6100]"}, \
+	{0x1002, 0x6641, CHIP_BONAIRE|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Saturn PRO [Radeon HD 8930M]"}, \
+	{0x1002, 0x6649, CHIP_BONAIRE|RADEON_NEW_MEMMAP, "Bonaire [FirePro W5100]"}, \
+	{0x1002, 0x6650, CHIP_BONAIRE|RADEON_NEW_MEMMAP, "Bonaire"}, \
+	{0x1002, 0x6651, CHIP_BONAIRE|RADEON_NEW_MEMMAP, "Bonaire"}, \
+	{0x1002, 0x6658, CHIP_BONAIRE|RADEON_NEW_MEMMAP, "Bonaire XTX [Radeon R7 260X]"}, \
+	{0x1002, 0x665C, CHIP_BONAIRE|RADEON_NEW_MEMMAP, "Bonaire XT [Radeon HD 7790/8770 / R9 260 OEM]"}, \
+	{0x1002, 0x665D, CHIP_BONAIRE|RADEON_NEW_MEMMAP, "Bonaire [Radeon R7 200 Series]"}, \
+	{0x1002, 0x6660, CHIP_HAINAN|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Sun XT [Radeon HD 8670A/8670M/8690M / R5 M330]"}, \
+	{0x1002, 0x6663, CHIP_HAINAN|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Sun PRO [Radeon HD 8570A/8570M]"}, \
+	{0x1002, 0x6664, CHIP_HAINAN|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Jet XT [Radeon R5 M240]"}, \
+	{0x1002, 0x6665, CHIP_HAINAN|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Jet PRO [Radeon R5 M230]"}, \
+	{0x1002, 0x6667, CHIP_HAINAN|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Jet ULT [Radeon R5 M230]"}, \
+	{0x1002, 0x666F, CHIP_HAINAN|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Sun LE [Radeon HD 8550M / R5 M230]"}, \
 	{0x1002, 0x6700, CHIP_CAYMAN|RADEON_NEW_MEMMAP, "Cayman GL XT [ATI FirePro V (FireGL V) Graphics Adapter]"}, \
 	{0x1002, 0x6701, CHIP_CAYMAN|RADEON_NEW_MEMMAP, "Cayman GL XT [ATI FirePro V (FireGL V) Graphics Adapter]"}, \
 	{0x1002, 0x6702, CHIP_CAYMAN|RADEON_NEW_MEMMAP, "Cayman GL XT [ATI FirePro V (FireGL V) Graphics Adapter]"}, \
@@ -241,6 +268,7 @@
 	{0x1002, 0x6819, CHIP_PITCAIRN|RADEON_NEW_MEMMAP, "Pitcairn PRO [Radeon HD 7800]"}, \
 	{0x1002, 0x6820, CHIP_VERDE|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Radeon HD 8800M Series"}, \
 	{0x1002, 0x6821, CHIP_VERDE|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Radeon HD 8800M Series"}, \
+	{0x1002, 0x6822, CHIP_VERDE|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Venus PRO [Radeon E8860]"}, \
 	{0x1002, 0x6823, CHIP_VERDE|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Radeon HD 8800M Series"}, \
 	{0x1002, 0x6824, CHIP_VERDE|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Chelsea [Radeon HD 7700M Series]"}, \
 	{0x1002, 0x6825, CHIP_VERDE|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Cape Verde [Radeon HD 7800M Series]"}, \
@@ -248,11 +276,13 @@
 	{0x1002, 0x6827, CHIP_VERDE|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Cape Verde [Radeon HD 7800M Series]"}, \
 	{0x1002, 0x6828, CHIP_VERDE|RADEON_NEW_MEMMAP, "Cape Verde"}, \
 	{0x1002, 0x6829, CHIP_VERDE|RADEON_NEW_MEMMAP, "Cape Verde"}, \
+	{0x1002, 0x682A, CHIP_VERDE|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Venus PRO"}, \
 	{0x1002, 0x682B, CHIP_VERDE|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Radeon HD 8800M Series"}, \
 	{0x1002, 0x682D, CHIP_VERDE|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Unknown device name"}, \
 	{0x1002, 0x682F, CHIP_VERDE|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Cape Verde [Radeon HD 7700M Series]"}, \
 	{0x1002, 0x6830, CHIP_VERDE|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Cape Verde [Radeon HD 7800M Series]"}, \
 	{0x1002, 0x6831, CHIP_VERDE|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP, "Cape Verde [AMD Radeon HD 7700M Series]"}, \
+	{0x1002, 0x6835, CHIP_VERDE|RADEON_NEW_MEMMAP, "Cape Verde PRX [Radeon R9 255 OEM]"}, \
 	{0x1002, 0x6837, CHIP_VERDE|RADEON_NEW_MEMMAP, "Cape Verde LE [Radeon HD 7700 Series]"}, \
 	{0x1002, 0x6838, CHIP_VERDE|RADEON_NEW_MEMMAP, "Cape Verde"}, \
 	{0x1002, 0x6839, CHIP_VERDE|RADEON_NEW_MEMMAP, "Cape Verde"}, \
@@ -572,6 +602,22 @@
 	{0x1002, 0x9808, CHIP_PALM|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Wrestler [Radeon HD 7340]"}, \
 	{0x1002, 0x9809, CHIP_PALM|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Wrestler [Radeon HD 7310]"}, \
 	{0x1002, 0x980A, CHIP_PALM|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Wrestler [Radeon HD 7290]"}, \
+	{0x1002, 0x9830, CHIP_KABINI|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Kabini [Radeon HD 8400 / R3 Series]"}, \
+	{0x1002, 0x9831, CHIP_KABINI|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Kabini [Radeon HD 8400E]"}, \
+	{0x1002, 0x9832, CHIP_KABINI|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Kabini [Radeon HD 8330]"}, \
+	{0x1002, 0x9833, CHIP_KABINI|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Kabini [Radeon HD 8330E]"}, \
+	{0x1002, 0x9834, CHIP_KABINI|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Kabini [Radeon HD 8210]"}, \
+	{0x1002, 0x9835, CHIP_KABINI|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Kabini [Radeon HD 8310E]"}, \
+	{0x1002, 0x9836, CHIP_KABINI|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Kabini [Radeon HD 8280 / R3 Series]"}, \
+	{0x1002, 0x9837, CHIP_KABINI|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Kabini [Radeon HD 8280E]"}, \
+	{0x1002, 0x9838, CHIP_KABINI|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Kabini [Radeon HD 8240 / R3 Series]"}, \
+	{0x1002, 0x9839, CHIP_KABINI|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Kabini [Radeon HD 8180]"}, \
+	{0x1002, 0x983A, CHIP_KABINI|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Unknown device name"}, \
+	{0x1002, 0x983B, CHIP_KABINI|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Unknown device name"}, \
+	{0x1002, 0x983C, CHIP_KABINI|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Unknown device name"}, \
+	{0x1002, 0x983D, CHIP_KABINI|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Temash [Radeon HD 8250/8280G]"}, \
+	{0x1002, 0x983E, CHIP_KABINI|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Unknown device name"}, \
+	{0x1002, 0x983F, CHIP_KABINI|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Unknown device name"}, \
 	{0x1002, 0x9900, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Unknown device name"}, \
 	{0x1002, 0x9901, CHIP_ARUBA|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Trinity [Radeon HD 7660D]"}, \
 	{0x1002, 0x9903, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Trinity [Radeon HD 7640G]"}, \
@@ -582,6 +628,10 @@
 	{0x1002, 0x9908, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Trinity [Radeon HD 7600G]"}, \
 	{0x1002, 0x9909, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Trinity [Radeon HD 7500G]"}, \
 	{0x1002, 0x990A, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Trinity [Radeon HD 7500G]"}, \
+	{0x1002, 0x990B, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Richland [Radeon HD 8650G]"}, \
+	{0x1002, 0x990C, CHIP_ARUBA|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Richland [Radeon HD 8670D]"}, \
+	{0x1002, 0x990D, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Richland [Radeon HD 8550G]"}, \
+	{0x1002, 0x990E, CHIP_ARUBA|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Richland [Radeon HD 8570D]"}, \
 	{0x1002, 0x990F, CHIP_ARUBA|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Unknown device name"}, \
 	{0x1002, 0x9910, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Trinity [Radeon HD 7660G]"}, \
 	{0x1002, 0x9913, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Trinity [Radeon HD 7640G]"}, \
@@ -593,6 +643,15 @@
 	{0x1002, 0x9992, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Trinity [Radeon HD 7420G]"}, \
 	{0x1002, 0x9993, CHIP_ARUBA|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Trinity [Radeon HD 7480D]"}, \
 	{0x1002, 0x9994, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Trinity [Radeon HD 7400G]"}, \
+	{0x1002, 0x9995, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Richland [Radeon HD 8450G]"}, \
+	{0x1002, 0x9996, CHIP_ARUBA|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Richland [Radeon HD 8470D]"}, \
+	{0x1002, 0x9997, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Richland [Radeon HD 8350G]"}, \
+	{0x1002, 0x9998, CHIP_ARUBA|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Richland [Radeon HD 8370D]"}, \
+	{0x1002, 0x9999, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Richland [Radeon HD 8510G]"}, \
+	{0x1002, 0x999A, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Richland [Radeon HD 8410G]"}, \
+	{0x1002, 0x999B, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Richland [Radeon HD 8310G]"}, \
+	{0x1002, 0x999C, CHIP_ARUBA|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Richland"}, \
+	{0x1002, 0x999D, CHIP_ARUBA|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Richland [Radeon HD 8550D]"}, \
 	{0x1002, 0x99A0, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Trinity [Radeon HD 7520G]"}, \
 	{0x1002, 0x99A2, CHIP_ARUBA|RADEON_IS_MOBILITY|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Trinity [Radeon HD 7420G]"}, \
 	{0x1002, 0x99A4, CHIP_ARUBA|RADEON_NEW_MEMMAP|RADEON_IS_IGP, "Trinity [Radeon HD 7400G]"}, \
-- 
2.3.7